#include "gprs-private.h"

typedef struct
{
  gchar *network_type;
  guint network_attrs;
  gchar *network_id;
  gprs_private *priv;
} gprs_network_identifier;

typedef struct
{
  gprs_private *priv;
  gchar *gprs_iface;
  int field_8;
  int field_C;
  int field_10;
  int field_14;
  gchar *network_type;
  guint network_attrs;
  gchar *network_id;
  gchar *accesspointname;
  gchar *username;
  gchar *password;
  gchar *path;
  int field_34;
  icd_nw_ip_addr_info_cb_fn ip_addr_info_cb;
  gpointer addr_info_cb_token;
  int field_40;
  int field_44;
  icd_nw_ip_up_cb_fn ip_up_cb;
  gpointer ip_up_cb_token;
  icd_nw_ip_down_cb_fn ip_down_cb;
  gpointer ip_down_cb_token;
  icd_nw_link_up_cb_fn link_up_cb;
  gpointer link_up_cb_token;
  icd_nw_link_post_up_cb_fn link_post_up;
  gpointer link_post_up_cb_token;
  icd_nw_link_down_cb_fn link_down_cb;
  gpointer link_down_cb_token;
  pid_t pid_up;
  pid_t pid_down;
  gchar *ip_address;
  gchar *ip_dns1;
  gchar *ip_dns2;
  int field_84;
  time_t ts;
  int field_8C;
  guint64 tx_bytes;
  guint64 rx_bytes;
} gprs_network;

gprs_network_identifier *create_network_identifier(gprs_network *gprs);
void free_network_identifier(gprs_network_identifier *id);
gprs_network *gprs_find(const gchar *network_type, const guint network_attrs, const gchar *network_id, gprs_private *priv);
gprs_network *gprs_find_by_identifier(gprs_network_identifier *id);
gprs_network *gprs_find_by_pid(pid_t pid, gprs_private *priv);
gprs_network *gprs_find_by_path(const gchar *path, gprs_private *priv);
gprs_network *gprs_find_by_id(const gchar *network_id, gprs_private *priv);
void gprs_clear_data(gprs_network *gprs);
gboolean gprs_network_is_always_online(gprs_network *gprs_net);
